/*
 * ListaMltiple.java
 *
 */
import javax.swing.*;
import javax.swing.event.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
/**
 *
 * @author Administrador
 */
public class ListaMltiple extends JApplet
        implements ListSelectionListener {
    
    // El panel tendr
    // un campo de texto y
    // una lista
    // JApplet deriva de JPanel
    // por que es un contenedor
    JTextField itemsElegidos;
    JList lista;
    
    /** Creates a new instance of ListaMltiple */
    public ListaMltiple() {
        
        // matriz de elementos de la lista
        String elementos[] = {"JList","JButton","Choice","JPanel","JApplet","JCheckbox"};
        
        // estos paneles se utilizan
        // para contener los resultados
        // de las selecciones
        JPanel pnlSuperior;
        JPanel subPanel;
        
        // gestor del objeto ListaMltiple
        setLayout(new BorderLayout());
        
        // color de fondo de ListaMltiple
        setBackground(Color.YELLOW);
        
       
        // se crea la lista con los elementos
        // de la matriz
        lista = new JList(elementos);
        
        // se registra la deteccin de eventos
        // de seleccin de elementos de la lista
        lista.addListSelectionListener(this);
        
        // se incluye scroll a la lista
        // y se aade la lista al contenedor
        // en el centro
        add(new JScrollPane(lista), "Center");
        
        // panel superior
        pnlSuperior = new JPanel();
        
        // subpanel para la constante
        // literal
        subPanel = new JPanel();
        
        // se le aade un literal
        subPanel.add(new JLabel("Valores elegidos:"));
        
        // en itemsElegidos se muestran los
        // elementos seleccionados
        // al ser seleccin mltiple
        // puede haber muchos elementos
        itemsElegidos = new JTextField(25);
        
        // se aade el componente al subpanel
        subPanel.add(itemsElegidos);
        
        // se aade el subpanel al panel superior
        pnlSuperior.add(subPanel);
        
        // se aade el panel superior a la parte North
        // del contenedor de ListaMltiple
        add(pnlSuperior,"North");
        
        
    }
    public static void main(String args[]){
        
        // se crea un JFrame
        JFrame jfr = new JFrame("Lista de seleccin mltiple");
        
        // se crea el panel de clase ListaMltiple
        ListaMltiple panel = new ListaMltiple();
         
        
        // se aade el panel de clase ListaMltiple
        // al centro del JFrame
        // ListaMltiple ya incluye los
        // paneles inferior y subpanel
        jfr.getContentPane().add(panel,"Center");
        
        // Tamao del JFrame
        jfr.setSize(450, 200);
        
        // Que se visualice
        jfr.setVisible(true);
        
        // se registra un gestor de escucha de ventana
        // para recibir eventos de ventana
        // se usa una clase que derivamos de WindowAdapter
        // y denominaremos CerrarVentana
        jfr.addWindowListener(new CerrarVentana());
        
    }
    public void valueChanged(ListSelectionEvent e){
        
        // cuando se selecciona un elemento del objeto JList
        // se ejecuta este cdigo
        // o cuando se deselecciona
        // este es el mtodo relacionado con
        // ListSelectionListener
        int cantElementos = 0;
        int ix=0;
        
        String listaTextual ="";
        ListModel listData = lista.getModel();
        
        // matriz de elementos seleccionados
        Object elementosSeleccionados[];
        
        // obtiene los valores seleccionados
        // el mtodo getSelectedValues()
        // nos devuelve una matriz con los
        // elementos actualmente seleccionados
        elementosSeleccionados = lista.getSelectedValues();
        
        // obtiene la cantidad de elementos seleccionados
        if (elementosSeleccionados != null)
            cantElementos = elementosSeleccionados.length;
        
        // recorremos la matriz para generar el cuadro
        // de texto
        for(ix=0;ix<cantElementos;ix++){
            if(ix!=0) listaTextual+=" ";
            listaTextual += elementosSeleccionados[ix].toString();
        }
        
        // se asigna el cuadro de texto
        itemsElegidos.setText(listaTextual);
        
        
    }
    
} // fin clase ListaMltiple

class CerrarVentana extends WindowAdapter
        // esta clase es la que recibe los eventos
        // de ventana
{
    public void windowClosing(WindowEvent e){
        // windowClosing() se invoca cuando
        // el usuario intenta cerrar la ventana
        // desde el men del sistema de la ventana
        Window ventana = e.getWindow();
        
        // se hace no visible
        ventana.setVisible(false);
        
        // se deshace del objeto
        ventana.dispose();
        
        System.exit(0);
        
    }
}


