/*
 * Main.java
 *
 * Created on 24 de abril de 2006, 12:45
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package cap11;
import java.io.*;
import java.util.*;
import org.ed.mibib.*;

/**
 *
 * @author Administrador
 */
public class Main {
    
    /** Creates a new instance of Main */
    public Main() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // Ejemplos con flujos de datos
        
        //Ejemplo1101InputStream();
        //Ejemplo1102InputStream();
        //Ejemplo1103OutputStream();
        //Ejemplo1104Reader();
        //Ejemplo1105Writer();
        //Ejemplo1106DataInputStream();
        //Ejemplo1107File();
        //Ejemplo1108File();
         Ejemplo1100Serializacin();
         Ejemplo1100Deserializacin();
        
    }
    
    public static void Ejemplo1101InputStream()  {
        // Ejemplos con flujos de datos
        
        InputStream miArchivo;
        try {
            miArchivo =  new FileInputStream("C:\\archivo1.java");
            int i = miArchivo.read();
            while (i != -1){
                System.out.println("ley = " + i);
                i = miArchivo.read();
            }
        } catch (IOException e) {
            System.err.println("Excepcin " + e.getMessage());
            
        }
        
        
        
    }
    
    public static void Ejemplo1102InputStream()  {
        // Ejemplos con flujos de datos
        
        InputStream miArchivo;
        byte b[] = {0, 0};
        int j = 0;
        
        // lectura en una matriz
        // los bytes ledos dependen de la
        // longitud de la matriz
        // en este caso la lectura es de a 2
        
        try {
            miArchivo =  new FileInputStream("C:\\archivo1.java");
            // leemos en la matriz b
            // en la variable i se detecta el final de archivo
            // y la cantidad de bytes ledos realmente
            // ojo en la ltima lectura ya que
            // la matriz puede ser ms larga que
            // la cantidad de bytes pendientes
            // tal como sucede en este caso, ya que hay
            // 9 bytes y 5 lecturas de a 2 bytes
            int i = miArchivo.read(b);
            
            while (i != -1){
                
                // ya sabemos cuntos bytes quedan en el archivo
                System.out.println("Ley en la matriz b y adems hay disponibles:" + miArchivo.available());
                System.out.println("Bytes ledos en laltima lectura i:" + i);
                
                // se listan tantos bytes como los que se hayan ledo
                // en la ltima lectura
                for (j=0;(j < i);j++){
                    System.out.println(b[j]);
                }
                
                // vuelve a leer en la matriz
                i = miArchivo.read(b);
                
            }
        } catch (IOException e) {
            System.err.println("Excepcin " + e.getMessage());
            
        }
        
        
        
    }
    
    public static void Ejemplo1103OutputStream()  {
        // Ejemplos con flujos de datos
        
        InputStream miArchivoIn;
        OutputStream miArchivoOut;
        
        // lectura de a un byte
        // insertando fin de lnea
        
        try {
            miArchivoIn =  new FileInputStream("C:\\archivo1.java");
            miArchivoOut =  new FileOutputStream("C:\\archivo1Out.java");
            
            int i = miArchivoIn.read();
            
            while (i != -1){
                System.out.println("Escribiendo en el flujo de datos...");
                miArchivoOut.write(i);
                miArchivoOut.write(10);
                // vuelve a leer
                i = miArchivoIn.read();
                
            }
        } catch (IOException e) {
            System.err.println("Excepcin " + e.getMessage());
            
        }
        
        
    }
    
    public static void Ejemplo1104Reader()  {
        // Ejemplos con flujos de caracteres
        // uso de FileReader
        
        BufferedReader miArchivo;
        String ln = null;
        
        try {
            miArchivo =  new BufferedReader(new  FileReader("C:\\archivo1.java"));
            
            
            ln = miArchivo.readLine();
            while (ln != null){
                System.out.println("ley = " + ln);
                ln = miArchivo.readLine();
            }
        } catch (IOException e) {
            System.err.println("Excepcin " + e.getMessage());
            
        }
        
        
        
    }
    
    public static void Ejemplo1105Writer()  {
        // Ejemplos con flujos de caracteres
        // uso de FileWriter
        
        
        BufferedReader miArchivo;
        FileWriter miSalida;
        String ln = null;
        
        
        
        try {
            miArchivo =  new BufferedReader(new  FileReader("C:\\archivo1.java"));
            miSalida =  new  FileWriter("C:\\archivo2.java");
            
            
            ln = miArchivo.readLine();
            while (ln != null){
                System.out.println("ley = " + ln);
                
                ln = ln + " algo que se agrega";
                System.out.println("escribir = " + ln);
                
                // escribe una cadena completa
                miSalida.write(ln, 0, ln.length());
                
                // vuelve a leer una lnea
                ln = miArchivo.readLine();
            }
        } catch (IOException e) {
            System.out.println("Excepcin " + e.getMessage());
            
        }
        
    }
    
    public static void Ejemplo1106DataInputStream()  {
        // Ejemplos con flujos de caracteres
        // uso de DataInputStream y DataOutputStream
        
        
        DataInputStream miArchivo;
        DataOutputStream miSalida;
        char ch;
        int i = 1;
        
        
        
        try {
            miArchivo =  new DataInputStream(new  FileInputStream("C:\\archivo1.java"));
            miSalida =  new  DataOutputStream(new FileOutputStream("C:\\archivo2.java"));
            
            
            ch = miArchivo.readChar();
            
            while (true) {
                System.out.println("ley = " + ch);
                
                // escribe lo ledo
                miSalida.writeChar(ch);
                // y aade algo ms
                miSalida.writeInt(i++);
                
                // vuelve a leer un char
                ch = miArchivo.readChar();
            }
        } catch (EOFException e) {
            System.out.println("Fin de archivo " + e.getMessage());
            
        } catch (IOException e) {
            System.out.println("Excepcin " + e.getMessage());
            
        }
        
    }
    
    
    public static void Ejemplo1107File()  {
        // Ejemplos con clase File
        // creacin de un objeto File
        
        File arch = new File("C:\\archivo1.java");
        String str;
        
        // primero verificamos que exista
        if (!arch.exists()){
            System.out.println("El archivo " + arch.getName() + " no existe. No se hacen otras comprobaciones");
            return;
        }
        
        // primero verificamos si es archivo o carpeta exista
        if (arch.isFile()){
            System.out.println(arch.getName() + " es un archivo.");
            System.out.println("Tamao del archivo: " + arch.length());
            // verifica si el archivo es de lectura
            if (!arch.canRead()){
                System.out.println("El archivo " + arch.getName() + " no se puede leer.");
            } else {
                System.out.println("El archivo " + arch.getName() + " se puede leer.");
            }
            
            // verifica si el archivo es de escritura
            if (!arch.canWrite()){
                System.out.println("El archivo " + arch.getName() + " no se puede escribir.");
            } else {
                // primero verificamos que exista
                if (!arch.exists()){
                    System.out.println("El archivo " + arch.getName() + " no existe. No se hacen otras comprobaciones");
                    return;
                }
            }
        } else {
            // es carpeta
            
            System.out.println(arch.getName() + " es una carpeta")  ;
        }
        
        // informa su directorio principal
        str = arch.getParent();
        if (str != null){
            System.out.println("La carpeta principal de " + arch.getName() + " es " + str);
        }
        
        // informa la hora de la ltima modificacin
        Date fecha = new Date();
        fecha.setTime(arch.lastModified());
        System.out.println("La ltima modificacin fue " + fecha);
        
        
    }
    
    public static void Ejemplo1108File()  {
        // Ejemplos con clase File
        // creacin de un objeto File
        
        File arch = new File("C:\\archivo3.java");
        
        
        try {
            // primero verificamos si existe
            if (arch.exists()){
                System.out.println("Elimina el archivo");
                arch.delete();
            }
            arch.createNewFile();
        } catch (IOException e){
            System.out.println("Excepcin en la creacin del archivo");
        }
        
        
        
        
    }
    
    public static void Ejemplo1100Serializacin()  {
        
        // Creamos un objeto serializable y lo serializamos
        
        Ejemplo1100Serializable os = new Ejemplo1100Serializable("Pepe Gmez");
        
        // serializar el objeto
        os.saveObject();
        
        System.out.println("Objeto serializado en archivo");
        
        
    }
    public static void Ejemplo1100Deserializacin()  {
        
        try{
            // se obtiene el archivo que contiene la serializacin
            FileInputStream arch = new FileInputStream("c:\\xxx.obj");
            
            // se crea el flujo de objetos
            ObjectInputStream ois = new ObjectInputStream(arch);
            
            // se lee el objeto y se convierte a la clase correspondiente
            Ejemplo1100Serializable os = (Ejemplo1100Serializable)ois.readObject();
            
            ois.close();
            arch.close();
            
            // comprobamos que es el objeto serializado
            System.out.println("Objeto deserializado en archivo NOMBRE: " + os.nombre);
        } catch (Exception e) {
            System.out.println(e);
        }
        
        
        
    }
}
