/*
 * Ejemplo1504Thread.java
 *
 */

/**
 *
 * @author Administrador
 */
public class Ejemplo1504Thread extends Thread {
    // en este ejemplo utiliza el mtodo join() para
    // que un proceso espere la finalizacin de
    // otro subproceso
    
    // propiedades de la clase
    // msg mensaje
    // lContar para contar el bucle
    // lSleep para personalizar el tiempo
    // suspensin del subproceso
    String msg;
    long lContar;
    int lSleep;
    
    // variable de clase
    static long lSumar;
    
    
    /** Creates a new instance of Ejemplo1504Thread */
    public Ejemplo1504Thread(String nombre, long c, int tiempo) {
        
        // constructor del objeto
        lContar = c;
        msg = nombre;
        lSleep = tiempo;
        
        // avisa que se est ejecutando
        // comprobar que se inician ordenadamente
        // pero terminarn desordenadamente dado
        // que tienen diferentes tiempos de sleep
        System.out.println(nombre + ": ejecutando Thread");
        
    }
    // hay que implementar el mtodo run()
    public void run() {
        // el bucle lContar se hace
        // desde lContar hasta cero
        while(lContar-- > 0 ){
            try {
                
                Thread.sleep(lSleep);
                
                
                // se suma en la variable de clase lSumar
                lSumar++;
                
                // situacin del contador
                System.out.println(msg + ":  lSumar: " + lSumar );
                
            } catch (InterruptedException e) {
                return;
                
            }
        }
        System.out.println(msg + ": finalizado, estado de la suma lSumar: " + lSumar);
        
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // se generan tres ejemplares
        // cada uno se ejecutar en un subproceso diferente
        // y con tiempos de espera diferentes
        // el tiempo es en milisegundos
        new Ejemplo1504Thread("Primer subproceso :", 4, 50).start();
        
        // el segundo subproceso lo iniciamos
        // con un objeto con nombre para
        // poder utilizar el mtodo join()
        Thread sp;
        sp = new Ejemplo1504Thread("Segundo subproceso :", 4, 12);
        sp.start();
        try {
            // con esto se indica que el subproceso vigente
            // es decir, el main, queda a la espera que termine
            // el segundo subproceso
            // es como secuencializar el procesamiento
            sp.join();
        } catch (InterruptedException e) {
            System.out.println("InterruptedException");
        }
        
        // ahora seguimos con el proceso
        // el tercer subproceso no se iniciar
        // hasta que no termine el segundo subproceso
        new Ejemplo1504Thread("Tercer subproceso :", 4, 100).start();
        
    }
    
}