/*
 * Ejemplo1507Thread.java
 *
 */

/**
 *
 * @author Administrador
 */
public class Ejemplo1507Thread  {
    // este ejemplo es simple: un mismo mtodo
    // con synchronized funciona perfecto y sin
    // synchronized falla estrepitosamente
    // en el ejemplo se han puesto bucles para que los mtodos
    // duren ms y para que el fallo se produzca con mayor
    // facilidad
    
    class Cajero {
        // la clase Cajero
        // contiene la cuenta de
        // las localidades vendidas
        int localidades = 0;
        
        Cajero(){
            System.out.println("Constructor Cajero ");
        }
        public synchronized void sumarSinc() {
            // CORRECTO
            // el mtodo sumarSinc() est
            // sincronizado
            // su uso evita que los subprocesos
            // accedan simultneamente al
            // contador de localidades
            int iTemp;
            
            // leemos el valor de localidades
            // y lo sumamos despus del bucle
            // para provocar el error ms fcilemte
            iTemp = localidades;
            
            // este bucle intil est puesto
            // para que el mtodo dure ms tiempo
            // y aumenten las posibilidades
            // que los subprocesos se pisen entre s
            int cont =1000;
            while(cont-- > 0){}
            
            // sumamos uno
            localidades = iTemp + 1;
            
        }
        
        public  void sumarNoSinc() {
            // INCORRECTO
            // el mtodo sumarNoSinc() no est
            // sincronizado
            // su uso provoca que los subprocesos
            // accedan simultneamente al
            // contador de localidades
            int iTemp;
            
            // leemos el valor de localidades
            // y lo sumamos despus del bucle
            // para provocar el error ms fcilemte
            iTemp = localidades;
            
            // este bucle intil est puesto
            // para que el mtodo dure ms tiempo
            // y aumenten las posibilidades
            // que los subprocesos se pisen entre s
            int cont =1000;
            while(cont-- > 0){}
            
            // sumamos uno
            localidades = iTemp + 1;
            
        }
    }
    
    class Terminal extends Thread{
        // la clase Terminal
        // genera un subproceso para su ejecucin
        Cajero c;
        Terminal(Cajero Cajero) {
            System.out.println("constructor de Terminal ");
            // el objeto cajero siempre es el mismo
            // para que todos los  terminales
            // sumen en el mismo contador
            c = Cajero;
        }
        
        public void run() {
            // forzamos la venta de
            // 200000 localidades
            // si son tres terminales
            // se debern vender finalmente
            // 600000
            // eso ocurrir si se utiliza el mtodo sumarSinc()
            // que est sincronizado
            // cuando se usa el mtodo sumarNosinc()
            // se perdern sumas por el problema de la
            // falta de sincronizacin
            long cont = 200000;
            while(cont-- > 0){
                // probar las dos posibilidades
                // y verificar los resultados
                
                // en este ejemplo se pierden
                // casi el 50% de las sumas!!!
                // por no usar synchronized
                 c.sumarNoSinc();
                
                // con sumarSinc el resultado ser 600000
                //c.sumarSinc();
            }
        }
    }
    
    public  Ejemplo1507Thread(){
        System.out.println("constructor de 1507Thread ");
        
        // se crea un objeto Casero
        Cajero Cajero = new Cajero();
        
        // se crean los terminales todos
        // apuntando al cajero
        Terminal Ter1 = new Terminal(Cajero);
        Terminal Ter2 = new Terminal(Cajero);
        Terminal Ter3 = new Terminal(Cajero);
        
        // se inician los subprocesos
        Ter1.start();
        Ter2.start();
        Ter3.start();
        
        try {
            // nos ponemos a la espera
            // de la finalizacin de los
            // subprocesos
            Ter1.join();
            Ter2.join();
            Ter3.join();
        } catch (InterruptedException e){}
        
        // veremos el resultado:
        // lo correcto es que la suma sea 600000
        System.out.println("fin del programa " + Cajero.localidades);
        
    }
    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        System.out.println("main XX");
        new Ejemplo1507Thread();
    }
}