/*
 * Ejemplo1901Mail.java
 *
 */

import java.io.*;
import java.util.*;
import javax.mail.*;
import javax.mail.internet.*;
 

/**
 *
 * @author Administrador
 */
public class Ejemplo1901Mail {
    // ejemplo de un envo de mensaje de correo hacia 
    // un servidor SMTP
    
    // destino del email TO
    protected String emailDest = "zzzzz@mail.com";
    
    // asunto del mensaje SUBJECT
    protected String emailAsunto = "tema xxxx";
    
    // cuerpo del mensaje BODY
    protected String emailBody = "..... cuerpo del mensaje ......";
    
    // sesin de Javamail
    protected Session emailSession;
    
    // mensaje
    protected Message msg;
     
    // envo del correo
    public void enviarEmail() {
        // propiedades
        // java.util.Properties
        Properties props = new Properties();
        
        // servidor SMTP
        // se asigna el nombre del host
        props.put("mail.hostname.es","mailhost");
        
        // creacin del objeto Session
        emailSession = Session.getDefaultInstance(props, null);
        
        try {
            // crea un mensaje
            // usa javax.mail.Internet.*
            // crea un objeto Message a partir del
            // objeto emailSession
            // MimeMessage es una subclase de Message
            msg = new MimeMessage(emailSession);
           
            // cabeceras FROM/TO/SUBJECT
            
            // origen del mensaje
            // usa InternetAddress javax.mail.Internet.*
            msg.setFrom(new InternetAddress("xxxxxxx@terra.es"));
            
            // destino
            InternetAddress TO = new InternetAddress(emailDest);
            msg.addRecipient(Message.RecipientType.TO, TO);
            
            // asunto
            msg.setSubject(emailAsunto);
            
            // texto del mensaje
            // cuerpo del mensaje
            msg.setText(emailBody);
            
            // Envo del mensaje
            Transport.send(msg);
            
            
        } catch (Exception e) {
            
            System.out.println("error: " + e.getMessage());
        }
        
    }
    
    /** Creates a new instance of Ejemplo1901Mail */
    public Ejemplo1901Mail() {
        
        // enviar un email
        enviarEmail();
        
    }
    public static void main(String[] args)  {
        new Ejemplo1901Mail();
        
    }
}
